image: docker:19.03.8

services:
  - docker:19.03.8-dind

stages:
- build
- push
- test
- deploy

include:
- template: Security/SAST.gitlab-ci.yml
- template: Security/Dependency-Scanning.gitlab-ci.yml
- template: Security/License-Scanning.gitlab-ci.yml
- template: Security/Container-Scanning.gitlab-ci.yml
- template: Code-Quality.gitlab-ci.yml

build:
  stage: build
  variables:
    IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  image: golang:1.17
  script:
    - go build .

docker-push:
  stage: push
  variables:
    IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE .
    - docker push $IMAGE

deploy-staging:
  image: registry.gitlab.com/gitlab-org/cluster-integration/helm-install-image/releases/3.2.4-kube-1.13.12
  stage: deploy
  variables:
    IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
    HELM_HOST: "localhost:44134"
  script:
    - kubectl config use-context tech-marketing/devsecops/initech/vuln-reporter:initech-reporter
    - helm upgrade -f helm/values.yaml --set image=$IMAGE --set project=$PROJECT_ID --set token="$ACCESS_TOKEN" --install reporter ./helm
  environment:
    name: staging
  allow_failure: true
